Page MenuHomePhabricator

[Task] ESC key should close property suggester dropdown and statement edit mode
Closed, ResolvedPublic

Description

Currently there is a race conditions in the UI for editing an item value in a statement: After typing but before the PropertySuggester shows its item suggestions or if the property suggester is not deployed, ESC cancels the edit. If the PropertySuggester shows, ESC only closes the property suggester. So the current behavior is different depending on latency.

One solution is to pass on the ESC from the PropertySuggester to cancel the edit. (Result is that there is no keyboard shortcut to only cancel the PropertySuggester anymore.)

Another solution would be to show the suggester at the same time as showing the edit field and still needing one ESC for closing the pop up and one for canceling the edit.

The PropertySuggester should behave the same way as the EntitySuggester and other popups.

This is also causing failures in the browsertests, since they don't check whether the property suggester is deployed or not.

Event Timeline

Tobi_WMDE_SW updated the task description. (Show Details)
Tobi_WMDE_SW raised the priority of this task from to Normal.
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptNov 4 2015, 11:13 AM

Please be more specific in writing these tasks.
Is this about a behavior change of the existing UI? Is this about testing something as the blocker seems to indicate?

This is about changing the exiting UI. Currently there is a race conditions in the UI for editing an item value in a statement. After typing but before the PropertySuggester shows its item suggestions, ESC cancels the edit. If the PropertySuggester shows, ESC only closes the property suggester. The current behavior is different depending on latency. Making the UI more predictable has the nice effect of allowing us to easily make a non-flaky browser test.

Ok thanks. This really isn't clear from the initial description.

Tobi_WMDE_SW updated the task description. (Show Details)Nov 9 2015, 11:05 AM
Tobi_WMDE_SW set Security to None.

@Lydia_Pintscher I've updated the task description according to @JanZerebecki's comment.

Tobi_WMDE_SW assigned this task to Jonas.
JanZerebecki updated the task description. (Show Details)May 11 2016, 1:19 PM

Change 288209 had a related patch set uploaded (by Jonas Kress (WMDE)):
Fix: Property suggester leads to test fail

https://gerrit.wikimedia.org/r/288209

Change 288209 merged by jenkins-bot:
Fix: Property suggester leads to test fail

https://gerrit.wikimedia.org/r/288209

Browsertests are failing, because when property suggester is present entity selector opens directly when entering edit mode.
There is no race condition whatsoever...

Jonas closed this task as Resolved.May 11 2016, 3:29 PM
JanZerebecki moved this task from Review to Doing on the Wikidata-Sprint-2016-05-10 board.

Change 288391 had a related patch set uploaded (by Jonas Kress (WMDE)):
Introduce step "I Close the entity selector if present"

https://gerrit.wikimedia.org/r/288391

thiemowmde closed this task as Resolved.May 12 2016, 2:10 PM
thiemowmde moved this task from Doing to Done on the Wikidata-Sprint-2016-05-10 board.

Thiemo asked me about my UX view on that issue. In general, the single-escape = out (Thiemos suggestion) makes sense, but I can not judge how much people may rely on that and got used to it.

If we deem this as important (or just interesting) we could make this part of a small, informal usability test – we could ask in-house, since I assume not everyone is familiar with data entry behavior in wikidata.